// MainFrm.cpp : implementation of the CMainFrame class
//


#define MAINFRAME_CPP


#include "stdafx.h"


#include "multidaorecordset.h"

#include "daothreadset.h"

#include "daothreaddoc.h"

#include "DAOTHREAD.h"

#include "MainFrm.h"

#include "DAOTHREADView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(WM_MULTIDAOMESSAGE, OnMultiDaoMessage)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


//jtm
//perform DAO functions in gui thread...
LONG CMainFrame::OnMultiDaoMessage( UINT uParam, LONG lParam)
{
	//jtm
	//based on switch, perform operation...
	CMultiDaoRecordSet *pSet = (CMultiDaoRecordSet *)lParam;
	LONG lRet = 0;

	CString cRet = "";
	COleVariant cVar;

	try
	{			
		//jtm-------debug--------------------------------------
		CString cTraceMessage = cDAOMessageArray[uParam];
		cTraceMessage += "\n";
		TRACE(cTraceMessage);
		//jtm-------debug--------------------------------------
		
		switch(uParam)
		{
			case MultiDaoOpen:
				pSet->Open();
				break;
			case MultiDaoClose:
				pSet->Close();
				break;
			case MultiDaoIsOpen:
				lRet = (LONG)pSet->IsOpen();
				break;
			case MultiDaoIsBOF:
				lRet = (LONG)pSet->IsBOF();
				break;
			case MultiDaoIsEOF:
				lRet = (LONG)pSet->IsEOF();
				break;
			case MultiDaoIsDeleted:
				lRet = (LONG)pSet->IsDeleted();
				break;
			case MultiDaoIsFieldDirty:
				lRet = (LONG)pSet->IsFieldDirty(pSet->pParam1);
				break;
			case MultiDaoIsFieldNull:
				lRet = (LONG)pSet->IsFieldNull(pSet->pParam1);
				break;
			case MultiDaoIsFieldNullable:
				lRet = (LONG)pSet->IsFieldNullable(pSet->pParam1);
				break;
			case MultiDaoGetName:
				cRet = pSet->GetName();
				lRet = (LONG)&cRet;
				break;
			case MultiDaoGetType:
				lRet = (LONG)pSet->GetType();
				break;
			case MultiDaoGetEditMode:
				lRet = (LONG)pSet->GetEditMode();
				break;
			case MultiDaoGetLastModifiedBookmark:
				cVar = pSet->GetLastModifiedBookmark();
				lRet = (LONG)&cVar;
				break;
			case MultiDaoGetRecordCount:
				lRet = (LONG)pSet->GetRecordCount();
				break;
			case MultiDaoMoveNext:
				pSet->MoveNext();
				break;
			case MultiDaoMovePrev:
				pSet->MovePrev();
				break;
			case MultiDaoMoveFirst:
				pSet->MoveFirst();
				break;
			case MultiDaoMoveLast:
				pSet->MoveLast();
				break;
			case MultiDaoMove:
				pSet->Move(*(LONG *)pSet->pParam1);
				break;
			case MultiDaoFindNext:
				lRet = (LONG)pSet->FindNext(*(LPCTSTR *)pSet->pParam1);
				break;
			case MultiDaoFindPrev:
				lRet = (LONG)pSet->FindPrev(*(LPCTSTR*)pSet->pParam1);
				break;
			case MultiDaoFindFirst:
				lRet = (LONG)pSet->FindFirst(*(LPCTSTR *)pSet->pParam1);
				break;
			case MultiDaoFindLast:
				lRet = (LONG)pSet->FindLast(*(LPCTSTR *)pSet->pParam1);
				break;
			case MultiDaoFind:
				lRet = (LONG)pSet->Find(*(LONG *)pSet->pParam1, *(LPCTSTR*)pSet->pParam2);
				break;
			case MultiDaoGetBookmark:
				cVar = pSet->GetBookmark();
				lRet = (LONG)&cVar;
				break;
			case MultiDaoSetBookmark:
				pSet->SetBookmark(*(COleVariant*)pSet->pParam1);
				break;
			case MultiDaoAddNew:
				pSet->AddNew();
				break;
			case MultiDaoEdit:
				pSet->Edit();
				break;
			case MultiDaoUpdate:
				pSet->Update();
				break;
			case MultiDaoDelete:
				pSet->Delete();
				break;
			case MultiDaoCancelUpdate:
				pSet->CancelUpdate();
				break;
			case MultiDaoRequery:
				pSet->Requery();
				break;
		}
	}
	catch (CDaoException *e)
	{
		TRACE("Database Multithread Operation Failed%s\n", 
			e->m_pErrorInfo->m_strDescription);
	}
	return lRet;
}


BOOL CALLBACK EnumChildProc(HWND hWnd, LPARAM lParam )
{
	CMainFrame *pMain = (CMainFrame *)lParam;
	
	//if the child window has a view pointer, then...
	CWnd *pWindow = pMain->FromHandlePermanent(hWnd);

	if (pWindow)
	{
		if (pWindow->IsKindOf(RUNTIME_CLASS( CDAOTHREADView ) ) )
		{
			((CDAOTHREADView *)pWindow)->m_bContinueThread = FALSE;
			((CDAOTHREADView *)pWindow)->DestroyWindow();
		}
	}

	return TRUE;
}


BOOL CMainFrame::DestroyWindow() 
{
	//jtm
	//check for any mdi windows. kill them first	
	EnumChildWindows(GetSafeHwnd(), // handle to parent window 
		(WNDENUMPROC)EnumChildProc, // pointer to callback function 
		(LPARAM)this); 
	
	return CMDIFrameWnd::DestroyWindow();
}
